#include <cfortran.h>
#include <hbook.h>
#include <math.h>

#if defined(__hpux) || defined(_IBMR2)
# define extname
#endif

#ifdef extname
#define UFIT ufit_
#else
#define UFIT ufit
#endif


#define PAWC_SIZE 50000

typedef struct { 
  float PAW[PAWC_SIZE]; 
} PAWC_DEF;
#define PAWC COMMON_BLOCK(PAWC,pawc)
COMMON_BLOCK_DEF(PAWC_DEF,PAWC);
PAWC_DEF PAWC;

typedef struct { 
  double dpar[24];
  double fitfun; 
} HCFITD_DEF;
#define HCFITD COMMON_BLOCK(HCFITD,hcfitd)
COMMON_BLOCK_DEF(HCFITD_DEF,HCFITD);
HCFITD_DEF HCFITD;

int h_shape=1000;


extern float ufit(float *xi)
{
         float a,b,c,d;
         float y, x;

         x = *xi;
         a=HCFITD.dpar[0];
         b=HCFITD.dpar[1];
         c=HCFITD.dpar[2];
         d=HCFITD.dpar[3];
         HCFITD.fitfun = b*exp(-b*(d-x))*pow(b*sqrt((x-d)*(x-d)),(a-1.))/c;
         y = HCFITD.fitfun;
         return (y);
}

void fill(int histo)
{
  HFILL(histo,1.,0.,0.0156);
  HFILL(histo,2.,0.,0.0579);
  HFILL(histo,3.,0.,0.1189);
  HFILL(histo,4.,0.,0.1528);
  HFILL(histo,5.,0.,0.1576);
  HFILL(histo,6.,0.,0.1382);
  HFILL(histo,7.,0.,0.0973);
  HFILL(histo,8.,0.,0.0705);
  HFILL(histo,9.,0.,0.0541);
  HFILL(histo,10.,0.,0.0381);
  HFILL(histo,11.,0.,0.0282);
  HFILL(histo,12.,0.,0.0211);
  HFILL(histo,13.,0.,0.0151);
  HFILL(histo,14.,0.,0.0112);
  HFILL(histo,15.,0.,0.0092);
  HFILL(histo,16.,0.,0.0058);
  HFILL(histo,17.,0.,0.0044);
  HFILL(histo,18.,0.,0.0032);
}

void fit(int histo)
{
  float par[4],step[4], pmin[4], pmax[4], sig[4], chi2;

  par[0]  = 3.9;
  par[1]  = 0.6;
  par[2]  = 5.3;
  par[3]  = 0.6;
  pmin[0] = 0.;
        pmin[1] = 0.;
        pmin[2] = 0.;
        pmin[3] = 0.;
        pmax[0] = 0.;
        pmax[1] = 0.;
        pmax[2] = 0.;
        pmax[3] = 0.;
        step[0] = -1.;
        step[1] = -1.;
        step[2] = -1.;
        step[3] = -1.;
        HFITH(histo,ufit," ",4 ,par,step,pmin,pmax,sig,chi2);
}

main()
{      
        int h_shape=1000;
        char title[80]="test";
        int step=18;
        float min=1.;
        float max=19.;
        char file[80]="fit.dat";

        HLIMIT(PAWC_SIZE);
        HBOOK1(h_shape,title,step,min,max,0.);
        fill(h_shape);
        fit(h_shape);
        HRPUT(0,file,"N");
}
